	//---------------------------------------//
	//	EBhENX
	//
	//	쐬ҁFDaiki Terai
	//	쐬F2010/11/29
	//	CF
	//---------------------------------------//

	#ifndef _WINDOWCLASS_H_
	#define _WINDOWCLASS_H_

	// EBhEYo[Ww
	#define _WIN32_WINNT 0x0500

	#include <tchar.h>
	#include <stdio.h>
	#include <stdlib.h>
	#include <windows.h>
	#include <windowsx.h>
	#include <commctrl.h>
	#pragma comment(lib,"comctl32.lib")
	#pragma comment(lib,"winmm.lib") 

	static const TCHAR* WC_BASIC = _T("Basic");		// {EBhENX

	// EBhENX
	class CSWindowClass
	{
	private:
		static HINSTANCE		m_hInstance;	// CX^Xnh
		HWND					m_hWnd;			// EBhEnh
		static	CSWindowClass*	m_pThis;		// o^p

	public:
		// RXgN^
		CSWindowClass();
		// fXgN^
		virtual ~CSWindowClass();

		// VvEBhENX̓o^
		static bool RegistBasicWindowClass(); 

		//--------------------------------------------------------------------//
		//	EBhE쐬
		//
		//	F		Title		^Cg
		//				Width		
		//				Height		
		//				X			XW
		//				Y			YW
		//				hParentWnd	eEBhEnh
		//				hMenu		j[nh̓\[XID
		//				ClassName	EBhENX
		//				Style		EBhEX^C
		//				ExStyle		EBhEgX^C
		//
		//	߂lF	true:	쐬
		//				false:	쐬s
		//--------------------------------------------------------------------//
		virtual bool CreateWnd(
			const TCHAR* Title,int Width = CW_USEDEFAULT,int Height = CW_USEDEFAULT,int X = CW_USEDEFAULT,int Y = CW_USEDEFAULT,
			HWND hParentWnd = NULL,HMENU hMenu = NULL,const TCHAR* ClassName = WC_BASIC,DWORD Style = WS_OVERLAPPEDWINDOW | WS_VISIBLE,DWORD ExStyle = 0);

	private:
		// EBhEvV[W̊Ǘ
		static LRESULT CALLBACK WndProcManager(HWND hWnd,UINT msg,WPARAM wParam,LPARAM lParam);
		// EBhEvV[W
		LRESULT CALLBACK WndProc(HWND hWnd,UINT msg,WPARAM wParam,LPARAM lParam);

	public:

		// bZ[W[v
		static void MsgLoop(int ArrayLength = 0,CSWindowClass* pWindowArray = NULL);

		// bZ[WĂȂƂɂ鏈
		virtual void Idle();
		// EBhE쐬bZ[W
		virtual BOOL OnCreate(HWND hWnd,LPCREATESTRUCT lpCreateStruct);
		// EBhEjbZ[W
		virtual void OnDestroy(HWND hWnd);
		// EBhE`惁bZ[W
		virtual void OnPaint(HWND hWnd);
		// L[͊֌WbZ[W
		virtual void OnChar(HWND hWnd, TCHAR ch, int cRepeat);
		// }EX֘AbZ[W
		virtual void OnLButtonDown(HWND hWnd, BOOL isDoubleClick, int x, int y, UINT keyFlags);
		virtual void OnRButtonDown(HWND hWnd, BOOL isDoubleClick, int x, int y, UINT keyFlags);
		virtual void OnMButtonDown(HWND hWnd, BOOL isDoubleClick, int x, int y, UINT keyFlags);
		virtual void OnLButtonUp(HWND hWnd,int x, int y, UINT keyFlags);
		virtual void OnRButtonUp(HWND hWnd,int x, int y, UINT keyFlags);
		virtual void OnMButtonUp(HWND hWnd,int x, int y, UINT keyFlags);
		virtual void OnMouseMove(HWND hwnd, int x, int y, UINT keyFlags);
		virtual void OnMouseWheel(HWND hWnd, int xPos, int yPos, int zDelta, UINT fwKeys);


	};


	#endif // _WINDOWCLASS_H_