	#include "WindowClass.h"

	// CX^Xnh
	HINSTANCE CSWindowClass::m_hInstance = NULL;
	// o^p
	CSWindowClass* CSWindowClass::m_pThis = NULL;		

	// RXgN^
	CSWindowClass::CSWindowClass()
	:m_hWnd(NULL)
	{
	}

	// fXgN^
	CSWindowClass::~CSWindowClass(){
	}

	// VvEBhENX̓o^
	bool CSWindowClass::RegistBasicWindowClass(){ 

		m_hInstance = GetModuleHandle(NULL);

		/********************************************************/
		/*		EBhENX̒`ƍ쐬					*/
		/********************************************************/

		// VvEBhENXݒ
		WNDCLASSEX wcex ={sizeof(WNDCLASSEX), CS_HREDRAW | CS_VREDRAW | CS_DBLCLKS, WndProcManager, 0,0,m_hInstance,
			(HICON)LoadImage(NULL,MAKEINTRESOURCE(IDI_APPLICATION),IMAGE_ICON,0,0,LR_DEFAULTSIZE | LR_SHARED),
			(HCURSOR)LoadImage(NULL,MAKEINTRESOURCE(IDC_ARROW),IMAGE_CURSOR,0,0,LR_DEFAULTSIZE | LR_SHARED), 
			(HBRUSH)GetStockObject(WHITE_BRUSH), NULL, WC_BASIC , NULL};

		// VvEBhENX쐬
		if(!RegisterClassEx(&wcex)) 
			return false;

		return true;
	}

	//--------------------------------------------------------------------//
	//	EBhE쐬
	//
	//	F		Title		^Cg
	//				Width		
	//				Height		
	//				X			XW
	//				Y			YW
	//				hParentWnd	eEBhEnh
	//				hMenu		j[nh̓\[XID
	//				ClassName	EBhENX
	//				Style		EBhEX^C
	//				ExStyle		EBhEgX^C
	//
	//	߂lF	true:	쐬
	//				false:	쐬s
	//--------------------------------------------------------------------//
	bool CSWindowClass::CreateWnd(
								  const TCHAR* Title,int Width,int Height,int X ,int Y ,
								  HWND hParentWnd,HMENU hMenu,const TCHAR* ClassName,DWORD Style,DWORD ExStyle)
	{
		// dvFƂŐEBhEvV[WĂяo߂ɊoĂ܂
		m_pThis = this;

		/********************************************************/
		/*		EBhE̍쐬								*/
		/********************************************************/

		m_hWnd = CreateWindowEx(
			ExStyle,							//gEBhEX^C
			ClassName,							//EBhENX
			Title,								//^Cgo[ɂ̖O\܂
			WS_OVERLAPPEDWINDOW | WS_VISIBLE,	//EBhEX^C
			X,									//wW
			Y,									//xW
			Width,								//
			Height,								//
			hParentWnd,							//eEBhẼnhAeƂNULL
			hMenu,								//j[nhor\[XID
			m_hInstance,						//CX^Xnh
			NULL);

		// EBhE쐬s
		if (m_hWnd == NULL)
			return false;

		return true;
	}

	//-----------------------------------------------------//
	//  EBhEvV[W̊Ǘ
	//	{EBhENXł͂̊֐o^
	//	̊֐oRĊeEBhE̖{̃vV[WĂяo܂
	//
	//	F	hWnd	EBhEnh
	//			msg		bZ[W
	//			wParam	p[^
	//			lParam	p[^
	//
	//	߂lF
	//-----------------------------------------------------//
	LRESULT CALLBACK CSWindowClass::WndProcManager(HWND hWnd,UINT msg,WPARAM wParam,LPARAM lParam){

		CSWindowClass* pWindow = (CSWindowClass*)(LONG_PTR)GetWindowLong(hWnd,GWL_USERDATA);

		//this|C^擾łꍇ
		if( pWindow != NULL)
		{
			// {̃EBhEvV[WĂяobZ[W
			LRESULT lResult = pWindow->WndProc( hWnd, msg, wParam, lParam);
			return lResult;
		}
		//this|C^擾łȂꍇ
		else
		{
			// EBhE̍쐬̏ꍇ
			if( msg == WM_CREATE || msg == WM_INITDIALOG){
				// vpeBXgɃIuWFNg|C^(this|C^)ݒ肷
				SetWindowLongPtr( hWnd, GWL_USERDATA, (LONG)(LONG_PTR)(m_pThis) );
				//PRINT("Create %s\n",typeid(*m_Instance).name());// ǂ̃EBhE^CvȂ̂\
				// bZ[W̍đM
				SendMessage(hWnd,msg,wParam,lParam);

				m_pThis = NULL;	// o^̂ňꎞCX^X|C^i[̉
			}
		}

		return DefWindowProc(hWnd,msg,wParam,lParam);
	}


	//-----------------------------------------------------//
	//	EBhEvV[W
	//	ftHg̏DefWindowProc֐ōs
	//
	//	F	hWnd	EBhEnh
	//			msg		bZ[W
	//			wParam	p[^
	//			lParam	p[^
	//
	//	߂lF
	//-----------------------------------------------------//
	LRESULT CALLBACK CSWindowClass::WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam){

		switch(msg){
			HANDLE_MSG(hWnd,WM_CREATE,OnCreate);
			HANDLE_MSG(hWnd,WM_DESTROY,OnDestroy);
			HANDLE_MSG(hWnd,WM_PAINT,OnPaint);
			// L[{[h
			HANDLE_MSG(hWnd,WM_CHAR,OnChar);
			// }EX
			HANDLE_MSG(hWnd,WM_LBUTTONDOWN,OnLButtonDown);
			HANDLE_MSG(hWnd,WM_RBUTTONDOWN,OnRButtonDown);
			HANDLE_MSG(hWnd,WM_MBUTTONDOWN,OnMButtonDown);
			HANDLE_MSG(hWnd,WM_LBUTTONDBLCLK,OnLButtonDown);
			HANDLE_MSG(hWnd,WM_RBUTTONDBLCLK,OnRButtonDown);
			HANDLE_MSG(hWnd,WM_LBUTTONUP,OnLButtonUp);
			HANDLE_MSG(hWnd,WM_RBUTTONUP,OnRButtonUp);
			HANDLE_MSG(hWnd,WM_MBUTTONUP,OnMButtonUp);
			HANDLE_MSG(hWnd,WM_MOUSEMOVE,OnMouseMove);
			HANDLE_MSG(hWnd,WM_MOUSEWHEEL,OnMouseWheel);

			// MCIIʒmbZ[W
			case MM_MCINOTIFY:{ 
				MCI_PLAY_PARMS mciPlay;

				// ʒmbZ[Ws
				if (wParam != MCI_NOTIFY_SUCCESSFUL)
					return 0;
				
				// ʒuɖ߂
				mciSendCommand((MCIDEVICEID)lParam, MCI_SEEK, MCI_SEEK_TO_START, 0);

				mciPlay.dwCallback = (DWORD_PTR)hWnd;
				// [vĐ
				mciSendCommand((MCIDEVICEID)lParam, MCI_PLAY, MCI_NOTIFY, (DWORD_PTR)&mciPlay);

				return 0;
			}
		}
		return DefWindowProc(hWnd, msg, wParam, lParam);
	}

	// bZ[W[v
	void CSWindowClass::MsgLoop(int ArrayLength,CSWindowClass* pWindowArray){

		/********************************************************/
		/*		bZ[W[v								*/
		/********************************************************/

		MSG msg = {}; 
		while(msg.message != WM_QUIT) {
			if(PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)){
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}
			else{
				// bZ[WĂȂƂ鏈
				for(int i = 0;i < ArrayLength;++i){
					pWindowArray[i].Idle();
				}
			}
		}	    
	}

	// bZ[WĂȂƂɂ鏈
	void CSWindowClass::Idle(){
		// pɏ
	}

	// EBhE쐬bZ[W
	BOOL CSWindowClass::OnCreate(HWND hWnd,LPCREATESTRUCT lpCreateStruct){
		return TRUE;
	}

	// EBhEjbZ[W
	void CSWindowClass::OnDestroy(HWND hWnd){
		PostQuitMessage(0);
	}

	// EBhE`惁bZ[W
	void CSWindowClass::OnPaint(HWND hWnd){
		PAINTSTRUCT ps;
		HDC hdc = BeginPaint(hWnd,&ps);
		EndPaint(hWnd,&ps);
	}

	// L[̓bZ[W
	void CSWindowClass::OnChar(HWND hWnd, TCHAR ch, int cRepeat){}

	// }EX{^bZ[W
	void CSWindowClass::OnLButtonDown(HWND hWnd, BOOL isDoubleClick, int x, int y, UINT keyFlags){}
	// }EXE{^bZ[W
	void CSWindowClass::OnRButtonDown(HWND hWnd, BOOL isDoubleClick, int x, int y, UINT keyFlags){}
	// }EX^񒆃{^bZ[W
	void CSWindowClass::OnMButtonDown(HWND hWnd, BOOL isDoubleClick, int x, int y, UINT keyFlags){}
	// }EX{^チbZ[W
	void CSWindowClass::OnLButtonUp(HWND hWnd,int x, int y, UINT keyFlags){}
	// }EXE{^グbZ[W
	void CSWindowClass::OnRButtonUp(HWND hWnd,int x, int y, UINT keyFlags){}
	// }EX^񒆃{^チbZ[W
	void CSWindowClass::OnMButtonUp(HWND hWnd,int x, int y, UINT keyFlags){}
	// }EXړbZ[W
	void CSWindowClass::OnMouseMove(HWND hwnd, int x, int y, UINT keyFlags){}
	// }EXzC[bZ[W
	void CSWindowClass::OnMouseWheel(HWND hWnd, int xPos, int yPos, int zDelta, UINT fwKeys){}

